<template>
  <div class="tiny-hamburger">
    <client-only>
      <el-dropdown
        ref="dropdownRef"
        trigger="click"
        placement="bottom-start"
        popper-class="tiny-hamburger-dropdown"
        :popper-options="{
          modifiers: [
            {
              name: 'offset',
              options: {
                offset: [0, 20],
              },
            },
          ],
        }"
      >
        <div
          class="h-[16px] flex place-content-between w-[16px] flex-wrap hamburger-icon"
          :class="{ 'has-unread-message': isHasUnreadMessage }"
        >
          <IHamburger />
        </div>
        <template #dropdown>
          <el-dropdown-menu>
            <el-dropdown-item
              v-for="(tab, index) in tabs"
              :key="index"
              :icon="Plus"
              class="hamburger-element"
            >
              <NuxtLink
                :to="tab.to"
                class="flex flex-nowrap gap-6 user-center-element items-center"
                @click="onMenuItemClicked"
              >
                <SvgIcon class="w-4 h-4" :svg-name="tab.icon" />
                <div>
                  <span>{{ $t(tab.label) }}</span>
                </div>
                <MessagesMessageCount
                  v-if="unreadInfo.TotalCount && tab.label === 'messages'"
                  :count="unreadInfo.TotalCount"
                  :is-unread="true"
                  class="!ml-auto"
                ></MessagesMessageCount>
              </NuxtLink>
            </el-dropdown-item>
            <el-dropdown-item class="hamburger-element">
              <div class="relative flex flex-nowrap gap-6 user-center-element logout-button items-center" @click="logout">
                <SvgIcon class="w-4 h-4" svg-name="icon-sign-out" />
                <div>
                  <span>{{ $t("logout") }}</span>
                </div>
              </div>
            </el-dropdown-item>
          </el-dropdown-menu>
        </template>
      </el-dropdown>
    </client-only>
  </div>
</template>
<script setup lang="ts">
import useMenu from "@/composables/useMenu";
import IHamburger from "~/assets/icons/hamburger.svg?component";
import {
  useHeaderComponent,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import { store } from "~/store";
import { memberMessageStore } from "~~/store/member-message";

const isShowReferralPage = computed(() => store.state.IsShowReferralPage);

const { auth, isReferralV2Enabled, logout } = useHeaderComponent();
const route = useRoute();
const {
  isCashPlayer,
  isShowDepositWithdrawal,
  isShowPromotion,
  isShowReferral,
} = useMenu();
const { fetchMessages, unreadInfo } = useMessage();
const tabs = reactive([
  {
    to: "/deposit",
    label: "deposit",
    icon: "icon-deposit",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  {
    to: "/withdrawal",
    label: "withdrawal",
    icon: "icon-withdraw",
    display: isCashPlayer.value && isShowDepositWithdrawal.value,
  },
  { to: "/wallet", label: "wallet", icon: "icon-wallet-v2", display: true },
  { to: "/account", label: "account", icon: "icon-account-v2", display: true },
  {
    to: "/transaction-history",
    label: "statement",
    icon: "icon-transaction-history-v2",
    display: true,
  },
  {
    to: "/bet-history",
    label: "bet_history",
    icon: "icon-bethistory-v2",
    display: true,
  },
  {
    to: "/my-promotion",
    label: "promotion",
    icon: "icon-promotion-v2",
    display: isShowPromotion.value,
  },
  {
    to: "/referral",
    label: "referral",
    icon: "icon-referral",
    display:
      isCashPlayer.value &&
      isShowReferral.value &&
      !isReferralV2Enabled.value &&
      isShowReferralPage.value,
  },
  {
    to: "/referral-v2",
    label: "referral",
    icon: "icon-referral",
    display: isReferralV2Enabled.value && isShowReferralPage.value,
  },
  {
    to: "/messages",
    label: "messages",
    icon: "icon-message",
    display: true,
  },
]).filter((p) => p.display);
const dropdownRef = ref();
const onMenuItemClicked = () => {
  dropdownRef.value?.handleClose();
};
const isHasUnreadMessage = computed(() => {
  return memberMessageStore.getters.isHasUnreadMessage;
});
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
</script>
<style lang="scss">
.tiny-hamburger-dropdown.el-popper.is-light {
  border: none;
  background: transparent;
}
.tiny-hamburger {
  width: 48px;
  height: 40px;
  display: flex;
  justify-content: center;
  align-items: center;
  .bg-hamburger {
    background-color: var(--text);
  }
  .hamburger-icon {
    position: relative;
  }
  .el-tooltip__trigger {
    .text {
      fill: var(--text);
    }
  }
}
.hamburger-icon.has-unread-message::before {
  content: "";
  position: absolute;
  top: -2px;
  left: 14px;
  width: 4px;
  height: 4px;
  border-radius: 50%;
  background: var(--failure);
}
.el-dropdown__popper:has(.hamburger-element) {
  .el-dropdown-menu {
    background: var(--background2);
    padding: 8px 0;
    border-radius: 8px;
    position: relative;
    .el-dropdown-menu__item {
      padding: 0;
      a:hover, > div:hover  {
        svg {
          opacity: 1;
        }
      }
      a.router-link-exact-active, > div.router-link-exact-active {
        svg {
          opacity: 1;
        }
      }
      // a.router-link-exact-active::after {
      //   content: "";
      //   position: absolute;
      //   top: 0;
      //   left: 0;
      //   height: 100%;
      //   width: 3px;
      //   background: var(--primary);
      // }
      a, > div {
        position: relative;
        color: var(--text5);
        padding: 16px 24px;
        width: 280px;
        height: 48px;
        background: var(--background5);
        svg {
          opacity: 0.5;
          fill: var(--text5);
        }
      }
      .logout-button::before {
        content: "";
        position: absolute;
        top: 0;
        left: 24px;
        width: calc(100% - 48px);
        border-top: solid 1px var(--border);
      }
    }
  }
  .el-popper__arrow {
    display: none;
  }
}
</style>
